// Overloading by Ulrich Eisenecker, April 16, 2021

#include <iostream>
#include <iomanip> // because of fixed and setprecision()

using namespace std;

[[nodiscard]] 
   double estimatedRange(const double & remainingFuel,
                         const double & consumedFuel, 
                         const double & distanceTravelled);
[[nodiscard]] 
   double estimatedRange(const double & remainingFuel,
                         const double & consumedFuel);

int main()
{
   cout << fixed << setprecision(2)
        << "Estimated remaining range = "
        << estimatedRange(30.0,6.0) // arguments are liters 
        << " km\n"                  // and liter per 100 km
        << "Estimated remaining range = "
        << estimatedRange(15.0,12.0,200.0) // arguments are liters, 
                                           // liters, and km
        << " km"
        << endl;
}

double estimatedRange(const double & remainingFuel,
                      const double & consumedFuel, 
                      const double & distanceTravelled)
{
   return remainingFuel / (consumedFuel / distanceTravelled);
}

double estimatedRange(const double & remainingFuel,
                      const double & consumedFuel)
{
   return estimatedRange(remainingFuel,consumedFuel, 100.0);
}
