// TypeInformation by Ulrich Eisenecker, August 8, 2022

#include <iostream>
#include <type_traits> // Because of is_arithmetic<>, is_integral<>, 
                       // is_unsigned<>, is_signed<>,  
                       // is_floating_point<>, is_same<>.
#include <cstddef> // Because of std::nullptr_t.
using namespace std;

int main()
{
   cout << boolalpha
        << "is_arithmetic<>"
        << endl   
        << is_arithmetic<bool>::value << endl
        << is_arithmetic<char>::value << endl
        << is_arithmetic<int>::value << endl
        << is_arithmetic<double>::value << endl
        << is_arithmetic<nullptr_t>::value << endl;

   
   cout << "\nis_integral<>" << endl
        << is_integral<bool>::value << endl
        << is_integral<char>::value << endl
        << is_integral<int>::value << endl
        << is_integral<double>::value << endl
        << is_integral<nullptr_t>::value << endl;

   cout << "\nis_unsigned<>" << endl
        << is_unsigned<bool>::value << endl
        << is_unsigned<char>::value << endl
        << is_unsigned<int>::value << endl
        << is_unsigned<double>::value << endl
        << is_unsigned<nullptr_t>::value << endl;

   cout << "\nis_signed<>" << endl
        << is_signed<bool>::value << endl
        << is_signed<char>::value << endl
        << is_signed<int>::value << endl
        << is_signed<double>::value << endl
        << is_signed<nullptr_t>::value << endl;

   cout << "\nis_floating_point<>" << endl
        << is_floating_point<bool>::value << endl
        << is_floating_point<char>::value << endl
        << is_floating_point<int>::value << endl
        << is_floating_point<double>::value << endl
        << is_floating_point<nullptr_t>::value << endl;

   cout << "\nis_same<>" << endl
        << is_same<bool,bool>::value << endl
        << is_same<bool,int>::value << endl;

   cout << "\nis_same<>" << endl
        << is_same<int,signed int>::value << endl;
}
